<template>
  <div class="text-center">
    <span v-for="category in visibleCategories" :key="`home-catalog-category-${category.id}`">
      <v-menu open-on-hover bottom offset-y>
        <template v-slot:activator="{ on }">
          <v-btn
            rounded
            text
            nuxt
            :to="`${baseUrl}/${category.id}`"
            class="light-blue--text"
            v-on="on"
            v-text="category.name"
          ></v-btn>
        </template>

        <v-list dense>
          <v-list-item
            v-for="child in category.children"
            :key="`home-catagog-subcategory-${child.id}`"
            nuxt
            :to="`${baseUrl}/${child.id}`"
          >
            <v-list-item-title class="body-2" v-text="child.name"></v-list-item-title>
          </v-list-item>
        </v-list>
      </v-menu>
    </span>

    <v-menu open-on-hover bottom offset-y>
      <template v-slot:activator="{ on }">
        <v-btn rounded small v-on="on">...</v-btn>
      </template>

      <v-list dense>
        <v-list-item
          v-for="category in hiddenCategories"
          :key="`home-catagog-category-${category.id}`"
          nuxt
          :to="`${baseUrl}/${category.id}`"
        >
          <v-list-item-title class="body-2" v-text="category.name"></v-list-item-title>
        </v-list-item>

        <v-divider></v-divider>

        <v-list-item nuxt :to="baseUrl">
          <v-list-item-title class="body-2">{{ $t('button.all-categories') }}</v-list-item-title>
        </v-list-item>
      </v-list>
    </v-menu>
  </div>
</template>

<script>
export default {
  props: {
    categories: {
      type: Array,
      required: true,
    },

    menuBreakpoints: {
      type: Object,
      default: () => ({
        xs: 2,
        sm: 3,
        md: 5,
        lg: 8,
        xl: 10,
      }),
    },
  },

  data: () => ({}),

  computed: {
    baseUrl() {
      return process.env.CATALOG_BASE_URL
    },

    parentLimit() {
      const { name } = this.$vuetify.breakpoint
      return this.menuBreakpoints[name]
    },

    visibleCategories() {
      return this.categories.slice(0, this.parentLimit)
    },

    hiddenCategories() {
      return this.categories.slice(this.parentLimit)
    },
  },
}
</script>
